package com.cool.hot100.dp;

import java.util.Stack;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/26/13:53
 * DayNumber 3
 * Hard 3
 * Level 7
 * @Description 32. 最长有效括号
 * @Link https://leetcode.cn/problems/longest-valid-parentheses/description/?envType=study-plan-v2&envId=top-100-liked
 */
public class Num31 {
    /**
     * 栈解法
     *
     * @param s
     * @return
     */
    public int longestValidParentheses(String s) {
        Stack<Integer> stack = new Stack<>();
        int res = 0;
        stack.push(-1);
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) == '(') {
                stack.push(i);
            } else {
                stack.pop();
                if (stack.empty()) {
                    stack.push(i);
                } else {
                    res = Math.max(res, i - stack.peek());
                }
            }
        }
        return res;
    }

    /**
     * 动态规划解法
     *
     * @param s
     * @return
     */
    public int longestValidParentheses2(String s) {
        int max = 0;
        s = "a " + s;
        int[] dp = new int[s.length()];
        for (int i = 2; i < s.length(); i++) {
            if (s.charAt(i) == ')') {
                //s.charAt(i - dp[i - 1] - 1) == '('是在校验当前已组成有效括号的前一个括号是否为(,
                max = Math.max(max, dp[i]);
                if (s.charAt(i - 1) == ')') {
                    if (s.charAt(i - dp[i - 1] - 1) == '(') {
                        dp[i] = dp[i - 1] + 2 + dp[i - dp[i - 1] - 2];
                    }
                } else if (s.charAt(i - dp[i - 1] - 1) == '(') {
                    /*i-2-dp[i-1]为当前已经组成有效括号的前一个括号,这里的有效括号与
                    上面的有效括号不同，这里是算上当前括号的有效括号，用来应对()(())这样的数据*/
                    dp[i] = dp[i - 2 - dp[i - 1]] + 2 + dp[i - 1];

                }
            }

        }
        return max;
    }

    /**
     * 双指针
     *
     * @param s
     * @return
     */
    public int longestValidParentheses3(String s) {
        int left = 0, right = 0, max = 0;
        //从前往后右括号大于左括号，left和right都归0
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) == '(') {
                left++;
            } else {
                right++;
            }
            //left大于right先不管
            if (left == right) {
                max = Math.max(max, 2 * right);
            } else if (right > left) {
                //right大于left重新记
                left = right = 0;
            }
        }
        left = right = 0;
        //从后往前左括号大于右括号，left和right都归0
        for (int i = s.length() - 1; i >= 0; i--) {
            if (s.charAt(i) == '(') {
                left++;
            } else {
                right++;
            }
            if (left == right) {
                max = Math.max(max, 2 * left);
            } else if (left > right) {
                //left大于right重新记,这个很重要
                left = right = 0;
            }
        }
        return max;
    }

}
